#!/bin/sh -e

test $DEBIAN_SCRIPT_DEBUG && set -v -x

CONFIG=/etc/snort/snort.debian.conf
CONFIG_CHECKSUM=/var/lib/snort/snort.debian.conf.md5sum
# Create the checksum directory if it does not exist
if [ ! -d $(dirname $CONFIG_CHECKSUM) ]; then
    mkdir $(dirname $CONFIG_CHECKSUM)
fi

#. /usr/share/debconf/confmodule
test $DEBIAN_SCRIPT_DEBUG && set -v -x


FIRSTINST=
RECONFIGURE=
if [ "$1" = "reconfigure" ] || [ -n "$DEBCONF_RECONFIGURE" ]; then
  RECONFIGURE="true"
  else
  RECONFIGURE=
fi

if ([ "$1" = "install" ] || [ "$1" = "configure" ]) && [ -z "$2" ]; then
    FIRSTINST="yes"
fi

if [ -z "$RECONFIGURE" ] && [ -z "$FIRSTINST" ]; then
    UPGRADE="yes"
fi



case "$1" in
    install)
	;;
    upgrade)
	;;
    configure)

        # only mess with config file it exists; otherwise, assume that's the way the
        # user wants it, but only if upgrading
        if [ -e "$CONFIG" ] || [ -z "$UPGRADE" ]; then
          # similarly, check for the existence of the checksum file; if it doesn't
          # exist, assume that's the way the user wants it, but only if upgrading
            if [ -e "$CONFIG_CHECKSUM" ] || [ -z "$UPGRADE" ]; then
        # next, compare the current and stored checksums; if they do not match,
        # assume that's the way the user wants it ... upgrading etc
             if [ "$(md5sum "$CONFIG" 2>/dev/null)" = \
                  "$(cat "$CONFIG_CHECKSUM" 2>/dev/null)" ] || \
                  [ -z "$UPGRADE" ]; then
                    # they match; get ready to prepare a new version of the config file
                  overwrite_config="yes"
             fi
            fi
        fi

	# generate new config file
#	db_get snort/interface || true; 	INTERFACE="$RET"
#	db_get snort/address_range || true;	ADDRESS_RANGE="$RET"
#	db_get snort/disable_promiscuous || true; DISABLE_PROMISCUOUS="$RET"
#	db_get snort/send_stats || true;	STATS_SEND="$RET"
#	db_get snort/stats_rcpt || true;	STATS_RCPT="$RET"
#	db_get snort/stats_treshold || true;	STATS_THRESHOLD="$RET"
#	db_get snort/options || true;		OPTIONS="$RET"

	test "$DISABLE_PROMISCUOUS" = "true" && OPTIONS="$OPTIONS -p"

	# Failsafe in case the values above are blank (jfs)
	[ -z "$STATS_RCPT" ] && STATS_RCPT=root
	[ -z "$STATS_THRESHOLD" ] && STATS_THRESHOLD=1
	# STATS_RCPT=`echo "$STATS_RCPT" | sed -e 's/@/\\\\@/g' -e 's/,/\\\\,/g'`

        # Create the new configuration file based on debconf information
#        NEW_CONFIG=$(mktemp)

#	cat <<EOF >>"$NEW_CONFIG"
# snort.debian.config (Debian Snort configuration file)
#
# This file was generated by the post-installation script of the snort
# package using values from the debconf database.
#
# It is used for options that are changed by Debian to leave
# the original configuration files untouched.
#
# This file is automatically updated on upgrades of the snort package
# *only* if it has not been modified since the last upgrade of that package.
#
# If you have edited this file but would like it to be automatically updated
# again, run the following command as root:
#   dpkg-reconfigure snort

#DEBIAN_SNORT_HOME_NET="$ADDRESS_RANGE"
#DEBIAN_SNORT_OPTIONS="$OPTIONS"
#DEBIAN_SNORT_INTERFACE="$INTERFACE"
#DEBIAN_SNORT_SEND_STATS="$STATS_SEND"
#DEBIAN_SNORT_STATS_RCPT="$STATS_RCPT"
#DEBIAN_SNORT_STATS_THRESHOLD="$STATS_THRESHOLD"
#EOF

#        if ! cmp -s "$CONFIG" "$NEW_CONFIG"; then
#                if [ "$overwrite_config" = "yes" ] ;then
#                    cp "$NEW_CONFIG" "$CONFIG.dpkg-new"
#                    mv "$CONFIG.dpkg-new" "$CONFIG"
#                    md5sum "$CONFIG" > "$CONFIG_CHECKSUM"
#                else
#                    if [ ! -e "$CONFIG" ] ; then
#                        echo "snort: not updating $CONFIG; file does not exist" >&2
#                    else 
#                        if [ ! -e "$CONFIG_CHECKSUM" ] ; then
#                            echo "snort: not updating $CONFIG; no stored checksum available and it does not match the debconf database configuration" >&2
#                        else
#                            echo "snort: not updating $CONFIG; file has been customized" >&2
#                        fi
#                    fi
#                fi
#        else
#            # Update the md5sum file
#            md5sum "$CONFIG" > "$CONFIG_CHECKSUM"
#        fi
#        rm -f "$NEW_CONFIG"

	if [ -f /etc/snort/snort.conf ]; then
		# Ensure the config file is readable by root.root and mode 600
		if ! dpkg-statoverride --list /etc/snort/snort.conf >/dev/null
		then
			chown root:snort /etc/snort/snort.conf
			chmod 640 /etc/snort/snort.conf
		fi
	fi

#	db_stop
#
	# Check for left-over files from woody packages.
	OLDCONF=/etc/snort/snort.rules.conf
	if [ -f "$OLDCONF" ]; then
		mv "$OLDCONF" "$OLDCONF.OBSOLETE"
	fi

	;;
    abort-upgrade)
	;;
    *)
	echo "postinst called with unknown argument \`$1'" >&2
	exit 0
	;;
esac

#DEBHELPER#

exit 0
